// Package
package org.auxilum.opengl.robot;


public class RobotProgramExecutor implements Runnable
{
	private RobotProgram program = null;
	private RobotStatus robot = null;
	private RobotControlPanel robotControlPanel = null;
	
	private boolean stopped = false;
	private boolean paused = false;
	
	private Thread programThread = null;
	
	private double[][] moves = null;

	public RobotProgramExecutor(/*RobotProgram program,*/ RobotStatus robot, RobotControlPanel robotControlPanel) 
	{
		this.robotControlPanel = robotControlPanel;
		//this.program = program;
		this.robot = robot;
	}

		
	public void run()
	{
		for (int index = 0; index < moves[0].length; index++)
		{
			for (int axis = 0; axis < moves.length; axis++)
			{
				float newAngle = (float)(robot.getAxisAngle(axis) + moves[axis][index]);
				robot.setAxisAngle(axis, newAngle);
				robotControlPanel.setAxisValue(axis, (int)newAngle);
			}
			
			// Check if stopped
			if (stopped)
				break;
				
			// Check for pause
			while(paused)
			{
				try
				{
					programThread.sleep(50);
				}
				catch(InterruptedException exc)
				{
					// Ignore		
				}
			}
				
				
			// Sleep
			try
			{
				programThread.sleep(30);
			}
			catch (InterruptedException exc)
			{
				// Ignore
			}
			
			//System.out.println(index);
		}
		
		robotControlPanel.programFinished();
	}
	
	
	public void startRobotProgram(double[][] moves)
	{
		this.moves = moves;
		this.paused = false;
		this.stopped = false;
		
		if (programThread == null)
		{
			this.programThread = new Thread(this);
			//System.out.println("Thread created");
			this.programThread.start();
		}
	}
	
	public void pauseRobotProgram()
	{
		this.paused = true;
	}
	

	public void stopRobotProgram()
	{
		this.programThread = null;
		//System.out.println("Thread killed");
		this.stopped = true;
	}
}
