package org.auxilum.opengl.robot;

import javax.swing.ImageIcon;
import javax.imageio.*;
import java.awt.image.*;
import java.net.URL;
import java.io.*;
import java.nio.*;

import java.util.Map;
import java.util.HashMap;

import net.java.games.jogl.*;
import net.java.games.jogl.util.*;

public class Util 
{
	
	/**
	 * Method Util
	 **/
	public Util() 
	{
		// Nothing to init
	}	
	
	
	/**
	 *	Check if the library is available based on filename
	 **/	
	public static boolean checkLib(String libname)
	{
		String winLib = ".dll";
		
		// Only works for windows for now
		if (System.getProperty("os.name").toLowerCase().indexOf("win") > -1)
		{
			//Assume windows
			String libPath = System.getProperty("java.library.path");
			if (libPath == null)
			{
				return false;
			}
			String[] paths = libPath.split(File.pathSeparator);
			File tmpFile = null;
			for (int i = 0; i < paths.length; i++)
			{
				// Check for file
				tmpFile = new File(paths[i] + File.separator + libname + winLib);
				if (tmpFile.exists())
					return true;	
			}
			
			return false;
		}
		else
		{
			return true;
		}
	}
	
	
	/** 
	 *	Returns an ImageIcon, or null if the path was invalid. 
	 **/
	public static ImageIcon createImageIcon(String path) 
	{
        java.net.URL imgURL = RobotFrame.class.getResource(path);
        if (imgURL != null) 
        {
            return new ImageIcon(imgURL);
        }
        else 
        {
            System.err.println("Couldn't find file: " + path);
            return null;
        }
    }
}
