package org.auxilum.opengl.scene;


public class Material 
{
	
	// Attributes
	private String materialName = null;
	private float[] ambient = new float[4];
	private float[] diffuse = new float[4];
	private float[] specular = new float[4];
	private float[] emissive = new float[4];
	private float shininess = 0.0f;
	private float transparency = 0.0f;
	private Texture texture = null;
	private String textureName = null;
	
	
	/**
	 * Method Material
	 **/
	public Material(String materialName, float[] ambient, float[] diffuse, float[] specular, float[] emissive, float shininess, float transparency, String textureName) 
	{
		this.materialName = materialName;
		this.ambient = ambient;
		this.diffuse = diffuse;
		this.specular = specular;
		this.emissive = emissive;
		this.shininess = shininess;
		this.transparency = transparency;
		this.textureName = textureName;
	}	
	
	/**
	 *
	 **/
	public String getName()
	{
		return this.materialName;
	}
	
	
	/**
	 *
	 **/
	public float[] getAmbient()
	{
		return this.ambient;
	}
	
	/**
	 *
	 **/
	public float[] getDiffuse()
	{
		return this.diffuse;
	}
	
	/**
	 *
	 **/
	public float[] getSpecular()
	{
		return this.specular;
	}
	
	/**
	 *
	 **/
	public float[] getEmission()
	{
		return this.emissive;
	}
	
	public float getShininess()
	{
		return this.shininess;
	}	
	
	
	/**
	 *
	 **/
	public String getTextureName()
	{
		return this.textureName;
	}
	
	/**
	 *
	 **/
	public Texture getTexture()
	{
		return this.texture;
	}
	
	
	/**
	 *
	 **/
	public void setTexture(Texture texture)
	{
		this.texture = texture;	
	}
}