package org.auxilum.opengl.scene;


/** */
public class Mesh
{
	private String meshName = null;
	private int meshFlag = -1;
	private int meshMaterialIndex = -1;
	private double[][] vertices = null;
	private double[][] normals = null;
	private int[][] triangles = null;
	private Material material = null;
	
	
	/**
	 *
	 **/
	public Mesh(String meshName, int meshFlag, int meshMaterialIndex, double[][] vertices, double[][] normals, int[][] triangleIndexes)
	{
		this.meshName = meshName;
		this.meshFlag = meshFlag;
		this.meshMaterialIndex = meshMaterialIndex;
		this.vertices = vertices;
		this.normals = normals;
		this.triangles = triangleIndexes;
	}
	
	/**
	 *
	 **/
	public void setMaterial(Material material)
	{
		this.material = material;
	}
	
	
	/**
	 *
	 **/
	public double[][] getVerticeCoords()
	{
		return this.vertices;
	}
	
	
	/**
	 *
	 **/
	public double[][] getNormals()
	{
		return this.normals;
	}
	

	/**
	 *
	 **/
	public int[][] getTriangleCoordIndexes()
	{
		return this.triangles;
	}	
	
	
	/**
	 *
	 **/
	public int getMeshMaterialIndex()
	{
		return this.meshMaterialIndex;
	}
	
	
	/**
	 *	Method to get the <code>Material</code> object of this mesh.
	 **/
	public Material getMaterial()
	{
		return this.material;
	}
}